--script for http://spbtv.com/channels/ (17/10/2015)

   local UpdateID='SPBTV_TV01'
   local UseLocalLogo = nil

if UseLocalLogo == nil then
   local fhandle = io.open (m_simpleTV.MainScriptDir ..  "user/tvplaylists/tvmenu.ini")   
   if fhandle == nil then 
      UseLocalLogo = '1'
      return
   end
   local str = fhandle:read('*a')
   fhandle:close()

   UseLocalLogo = string.match(str,'UseLocalLogo=(%d);')
   if UseLocalLogo == nil then UseLocalLogo = 0 end
end

if UseLocalLogo == '1' then
   local sqlstr = 'Select main.id,main.pict from main where main.updateid like "%SPBTV_%";'
   local dTable = m_simpleTV.Database.GetTable(sqlstr)
   if dTable ~= nil and dTable[1] ~= nil then
     for k, v in ipairs(dTable) do 
        --debug_in_file(v.id .. '  ' .. v.pict .. '\n')
        m_simpleTV.Database.ExecuteSql('DELETE FROM Main WHERE (Main.Id=' .. v.id .. ');',true) 
     end
   end
end
-----------------------------------------------
 local session = m_simpleTV.WinInet.New("Opera/9.80 (Windows NT 6.1; U; ru) Presto/2.9.168 Version/11.52")
 if session == nil then return end

  --INTERNET_OPTION_CONNECT_TIMEOUT
  m_simpleTV.WinInet.SetOptionInt(session,2,5000,0)
  --INTERNET_OPTION_RECEIVE_TIMEOUT
  m_simpleTV.WinInet.SetOptionInt(session,6,8000,0)
-------------------------------------------

 m_simpleTV.OSD.ShowMessage("spbtv - start channels updating" ,0xFF00,10)

 local  tmpName = m_simpleTV.Common.GetTmpName()
 if tmpName == nil then return end 
 
  local tfile = io.open(tmpName,'w+')
  if tfile == nil then 
      os.remove(tmpName)
      return
  end
  
  tfile:write('#EXTM3U\n')
  tfile:close() 

 local url  = 'http://spbtv.com/channels/'
 local rc,answer=m_simpleTV.WinInet.Get(session,url)
 m_simpleTV.WinInet.Close(session)
 
  if rc~=200 then
 	   m_simpleTV.WinInet.Close(session)
 	   m_simpleTV.OSD.ShowMessage("Connection error - " .. rc ,255,10)
 	   return
  end

--debug_in_file(answer .. '\n')

 local tmp = findpattern (answer,'<div class="channel_lang_select">(.-)</div>',1,1,0)
 if tmp == nil then return end
--debug_in_file(tmp .. '\n')

 local lang,langName
 local t={}
 local i=1
   for w in string.gmatch(tmp,'<li>(.-)</li>') do

      lang = findpattern (w,'href="#(.-)"',1,7,1)
      langName = findpattern (w,'%b><',1,1,1)
      if lang == nil or langName == nil then break end
      t[i] = {}
      t[i][1] = lang
      t[i][2] = langName
--debug_in_file(lang .. '  ' .. langName .. '\n')
  i=i+1
   end

 local tmp2 = findpattern (answer,'<div id="channel_list2">(.-)</div>',1,1,0)
 if tmp2 == nil then return end
--debug_in_file(tmp2 .. '\n')

 local adr,name,img,grp
 local m3ustr

  local function GetGrp(lang)
    grp = ''
      for k, v in ipairs(t) do 
          if lang == v[1] then grp = v[2] end
     end 
    return grp
  end 

    for ww in string.gmatch(tmp2,'free tv"(.-)</li>') do

      adr = findpattern (ww,'id="(.-)"',1,4,1)
      grp = findpattern (ww,'class="lang">(.-)<',1,13,1)
      img = findpattern (ww,'span><img src="(.-)"',1,15,1)
      name = findpattern (ww,'autoplay">(.-)<',1,10,1)
      if adr == nil or grp == nil or img == nil or name == nil then break end
      grp = GetGrp(grp)
      img = 'http://spbtv.com' .. img
      adr = 'spbfreetv=' .. adr
--debug_in_file(grp .. '  ' .. name .. '  ' .. img .. '  ' .. adr .. '\n')

         if UseLocalLogo == '1' then    

              m3ustr = '#EXTINF:-1 update-code="' .. UpdateID .. grp .. name .. '" group-title="' .. grp .. '",' .. name .. '\n' .. adr .. '\n'

           elseif UseLocalLogo ~= '1' then

             m3ustr = '#EXTINF:-1 update-code="' .. UpdateID .. grp .. name .. '" group-title="' .. grp .. '" tvg-logo="' .. img .. '",' .. name .. '\n' .. adr .. '\n'

         end

        tfile = io.open(tmpName,'a+')
        tfile:write(m3ustr)
        tfile:close()

   end

--do return end

  --опции  для загрузки плейлиста 
local p={}
p.TypeSourse = 1
p.DeleteBeforeLoad = 0
p.TypeSkip   = 1
p.TypeFind =   0
p.AutoSearch = 1
p.NumberM3U =  1
p.Find_Group = 1
p.TypeCoding = 1  --  -1-auto  0 - plane text  1- UTF8  2- unicode
p.BorpasFileFormat=1
p.AutoNumber = 0
p.ExtFilter = 'SPB TV'
p.ExtFilterLogo =  '..\\Channel\\logo\\extFiltersLogo\\spbtv.png'   -- the logo of extended filter (from ver. 0.4.8 b9)
p.ExtFilterLogoForce = 0
p.UpdateID=UpdateID

local err,add,ref,names = m_simpleTV.Common.LoadPlayList (tmpName,p,0,true,false)
os.remove(tmpName)

if err==true then
     local mess = "spbtv - channels updated (" .. add .. ")"
	 if add > 0 and add < 25 then 
	    names = string.gsub(names,'%$end','\n')
		mess = mess .. '\n' .. names
	 end
	 
	 m_simpleTV.OSD.ShowMessage(mess,0x37BEDF,3) 
  end